#!/usr/bin/env bash

function getGCCVersion () {
    local res=""
    mkfifo gcc_version
    gcc -v 2> gcc_version &
    res="$(tail -n 1 gcc_version)"
    unlink gcc_version

    echo $res
}

function getOS () {
    cat /etc/os-release | grep --color=none "^PRETTY" | sed -s 's/PRETTY_NAME=//' | sed -s 's/\"//g'
}

function getArch () {
    echo $(uname -m | sed -s 's/_/\\_/g')
}

res="\\subsection{実行環境}\n\n"
res+="この課題のプログラムは以下の環境で動作することが確認されている：\n\n"
res+="\\\\begin{itemize}\n"
res+="    \\item OS: $(getOS)\n"
res+="    \\item CPU アーキテクチャ: \\\\texttt{$(getArch)}\n"
res+="    \\item C コンパイラ: \\\\texttt{$(getGCCVersion)}\n"
res+="    \\item C コンパイラオプション: \\\\texttt{}\n"
res+="\\\\end{itemize}"

echo -e "$res"
